/*
   You can compile and link this program with either Microsoft's cl
   or with gcc or with lcc. In all three cases, you will need the
   glut.h file in the same directory as your source code in order
   to compile and you will need the glut32.dll file in the same
   directory as the executable created by the compiler and linker
   in order to run the executable.

   To compile and link with with Microsoft's cl, just use a normal command,
      cl /Od /Zi /W1 /nologo /Fd"primitives.pdb" /MD primitives.c /link /nologo /subsystem:console  /pdb:none
   but you will need the glut.h, glut32.lib and glut32.dll files in the
   same directory as your source file.

   To compile and link with gcc use the command
      gcc -Wall -g -o primitives.exe  primitives.c -lopengl32 -lglu32 -lglut32
   You will need to have the glut.h, glut32.lib and glut32.dll files in the
   same directory as your source file.

   To compile and link with lcc use the command
      lcc -g2 -subsystem console  primitives.c opengl32.lib glu32.lib glut32.lib
   NOTE: Lcc needs the windows.h include file. Lcc does NOT need the glut32.lib file
   in the current directory. Lcc has a copy of glut32.lib in its default lib folder.
   In fact, if you do have a local copy of glut32.lib, it seems to cause lcc to hang.
*/
#include <windows.h>
#include <math.h>
#include "glut.h"
//#include <GLUT/glut.h>
//#include <GL/glut.h>


/* Prototype for the display callback function */
void display( void );


int main(int argc, char** argv)
{
   /* Standard GLUT initialization */
   glutInit(&argc,argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB); /* default, not needed */
   glutInitWindowSize(500,500);       /* 500 x 500 pixel window */
   glutInitWindowPosition(100,100);   /* place window near top left of display */
   glutCreateWindow("Fake animation");/* window title */
   glutDisplayFunc(display);          /* display callback invoked when window opened */

   /* Initialize OpenGL state */
   /* attributes */
   glClearColor(1.0, 1.0, 1.0, 1.0); /* white background */
   glColor3f(1.0, 0.0, 0.0);         /* draw in red */
   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(-1.0, 1.0, -1.0, 1.0); /* viewing volume */
   glMatrixMode(GL_MODELVIEW);

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}//main()


/* The display() callback function */
void display( void )
{
   float theta1 = 0.0;
   float theta2 = 0.0;
   float dtheta1 = 2.0*(3.14)/30.0;
   float dtheta2 = 2*dtheta1;

   /* The following loop repeatedly clears the screen and draws
   another line segment with each new line segment displaced just
   a little bit from the previous line segment. This creates the
   illusion of movement. The amount of time spent sleeping
   determines the "speed" of this "animation." */
   while(1)
   {
      glClear(GL_COLOR_BUFFER_BIT);  /* clear the window */
      glBegin(GL_LINES);             /* redraw the line */
        glVertex2f( 0.5*cos(theta1), 0.5*sin(theta1) );
        glVertex2f( cos(theta2), sin(theta2));
      glEnd();
      glFlush(); /* clear buffers */
      Sleep(70);
      theta1 += dtheta1;
      theta2 += dtheta2;
   }
}//display()
