/*
   You can compile and link this program with either Microsoft's cl
   or with gcc or with lcc. In all three cases, you will need the
   glut.h file in the same directory as your source code in order
   to compile and you will need the glut32.dll file in the same
   directory as the executable created by the compiler and linker
   in order to run the executable.

   To compile and link with with Microsoft's cl, just use a normal command,
      cl /Od /Zi /W1 /nologo /Fd"simple.pdb" /MD simple.c /link /nologo /subsystem:console  /pdb:none
   but you will need the glut.h, glut32.lib and glut32.dll files in the
   same directory as your source file.

   To compile and link with gcc use the command
      gcc -Wall -g -o simple.exe  simple.c -lopengl32 -lglu32 -lglut32
   You will need to have the glut.h, glut32.lib and glut32.dll files in the
   same directory as your source file.

   To compile and link with lcc use the command
      lcc -g2 -subsystem console  simple.c opengl32.lib glu32.lib glut32.lib
   NOTE: Lcc needs the windows.h include file. Lcc does NOT need the glut32.lib file
   in the current directory. Lcc has a copy of glut32.lib in its default lib folder.
   In fact, if you do have a local copy of glut32.lib, it seems to cause lcc to hang.
*/
#include <windows.h>   // needed by lcc and gcc (but not cl)
#include "glut.h"
//#include <GLUT/glut.h>
//#include <GL/glut.h>


/* Prototype for the display callback function */
void display( void );


int main(int argc, char** argv)
{
   /* Standard GLUT initialization */
   glutInit(&argc,argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB); /* default, not needed */
   glutInitWindowSize(500,500);    /* 500 x 500 pixel window */
   glutInitWindowPosition(50,50);  /* place window near top left of display */
   glutCreateWindow("Simple");     /* window title */
   glutDisplayFunc(display);       /* display callback invoked when window opened */

   /* Initialize OpenGL state */
   /* attributes */
   glShadeModel(GL_FLAT);
   glPolygonMode(GL_BACK, GL_LINE);
   glClearColor(1.0, 1.0, 1.0, 1.0); /* white background */
   glColor3f(1.0, 0.0, 0.0);         /* draw in red */
   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(-1.0, 1.0, -1.0, 1.0); /* viewing volume */
   glMatrixMode(GL_MODELVIEW);

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}//main()


/* The display() callback function */
void display( void )
{
   glClear(GL_COLOR_BUFFER_BIT);  /* clear the window */

   glBegin(GL_POLYGON);
      glVertex2f(-0.5, -0.5);
      glVertex2f(-0.5,  0.5);
      glVertex2f( 0.5,  0.5);
      glVertex2f( 0.5, -0.5);
   glEnd();

   glFlush(); /* clear buffers */
}//display()
